/*$Id: alert.js,v 1.6 2006/08/12 22:41:55 jwrobel Exp $*/
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Firekeeper.
 *
 * The Initial Developer of the Original Code is
 * Jan Wrobel <wrobel@blues.ath.cx>.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * the GNU General Public License Version 2 or later (the "GPL"), in
 * which case the provisions of the GPL are applicable instead of
 * those above. If you wish to allow use of your version of this file
 * only under the terms of the GPL, and not to allow others to use
 * your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the
 * notice and other provisions required by the GPL. If you do not
 * delete the provisions above, a recipient may use your version of
 * this file under the terms of any one of the MPL or the GPL.
 *
 * ***** END LICENSE BLOCK ***** */

var sentence = null;
var rule = null;

function urltoreg(url)
{
	url = url.replace(/\\/g, '\\\\');
	url = url.replace(/\./g, '\\.');
	url = url.replace(/\*/g, '\\*');
	url = url.replace(/\+/g, '\\+');
	url = url.replace(/\?/g, '\\?');
	url = url.replace(/\{/g, '\\{');
	url = url.replace(/\}/g, '\\}');
	url = url.replace(/\(/g, '\\(');
	url = url.replace(/\)/g, '\\)');
	url = url.replace(/\^/g, '\\^');
	url = url.replace(/\$/g, '\\$');
	url = url.replace(/\|/g, '\\|');
	url = url.replace(/\[/g, '\\[');
	url = url.replace(/\]/g, '\\]');
	url = "^" + url +"$";
	return url;
}

function alertInit()
{	
	getServices();
	var url = window.arguments[0];
	rule = window.arguments[1];
	sentence = window.arguments[2];
	
	var urlLabel = document.getElementById('url-label');
	urlLabel.setAttribute('value', url);
	var regUrlText = document.getElementById('regurl-textbox');
	regUrlText.setAttribute('value', urltoreg(url));

	if (rule.msg){
		var msgLabel = document.getElementById('msg-label');
		msgLabel.setAttribute('value', "*** " + rule.msg + " ***");
	}
	
	var count = {};
	var refnode = document.getElementById("references");	
	var references = rule.getReferences(count);

	if (count)
		refnode.setAttribute("hidden", "false");
	
	for(i = 0; i < count.value; i++){
		var link = document.createElement("label");
		var refurl = ""; 
		if (references[i].system == "url"){
			refurl = references[i].ruleId;
			if (refurl.length < 8 || refurl.substring(0, 7) != "http://")
				refurl = "http://" + refurl;
		}
		else if (references[i].system == "bugtraq")
			refurl = "http://www.securityfocus.com/bid/" 
				+ references[i].ruleId;
		else if (references[i].system == "cve")
			refurl = "http://cve.mitre.org/cgi-bin/cvename.cgi?name=" 
				+ references[i].ruleId;
		else if (references[i].system == "nessus")
			refurl = "http://cgi.nessus.org/plugins/dump.php3?id=" 
				+ references[i].ruleId;
		else if (references[i].system == "mcafee")
			refurl = "http://vil.nai.com/vil/dispVirus.asp?virus_k=" 
				+ references[i].ruleId;
		
		link.setAttribute("class", "url");
		link.setAttribute("value", refurl);
		link.setAttribute("onclick", "viewURL('" + refurl + "');");
		refnode.appendChild(link);
	}	

}


function block()
{
	sentence.action = sentence.BLOCK; 
	close();
}

function allow()
{	
	sentence.action = sentence.AUDIT; 
	close();
}

function whitelist()
{
	var url = document.getElementById('regurl-textbox').value;
	var reason = "Whitelisted. ";
	if (rule.msg)
		reason += rule.msg + " ";
	if (rule.fid)
		reason += "fid: " + rule.fid + " ";
	if (rule.rev)
		reason += "rev: " + rule.rev + " ";
	rulesLoader.whitelist(url, reason);
	sentence.action = sentence.DONT_AUDIT; 
	close();
}

function blacklist()
{
	var url = document.getElementById('regurl-textbox').value;
	var reason = "Blacklisted. ";
	if (rule.msg)
		reason += rule.msg + " ";
	if (rule.fid)
		reason += "fid: " + rule.fid + " ";
	if (rule.rev)
		reason += "rev: " + rule.rev + " ";
	rulesLoader.blacklist(url, reason);
	sentence.action = sentence.BLOCK; 
	close();
}


function viewURL(url)
{
	window.open(url, '_new', '');
}
